<?php

/**
 * @file
 * Define the API routes event.
 */

namespace Drupal\rest_easy\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\rest_easy\Plugin\APIInterface;

/**
 * Class APIRoutesEvent
 *
 * @package Drupal\rest_easy\Event
 */
class APIRoutesEvent extends Event {
  public const EVENT_NAME = 'rest_easy_api_routes_event';

  /**
   * @var \Drupal\rest_easy\Plugin\APIInterface
   *   The API plugin that generated the routes
   */
  public APIInterface $api;

  /**
   * @var \Symfony\Component\Routing\Route[]
   *   The routes that were generated
   */
  public array $routes;

  /**
   * APIRoutesEvent constructor.
   * 
   * @param \Drupal\rest_easy\Plugin\APIInterface $api_plugin
   * @param array $routes
   */
  public function __construct(APIInterface $api, array $routes) {
    $this->api = $api;
    $this->routes = $routes;
  }
}
