<?php

/**
 * @file
 * Define the endpoint access event.
 */

namespace Drupal\rest_easy\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\Core\Access\AccessResultInterface;
use Drupal\rest_easy\Plugin\EndpointInterface;

/**
 * Class EndpointAccessEvent
 *
 * @package Drupal\rest_easy\Event
 */
class EndpointAccessEvent extends Event {
  public const EVENT_NAME = 'rest_easy_endpoint_access_event';

  /**
   * @var \Drupal\rest_easy\Plugin\EndpointInterface
   *   The endpoint plugin being accessed
   */
  public EndpointInterface $endpoint;

  /**
   * @var AccessResultInterface
   *   The access result about to be returned
   */
  public AccessResultInterface $result;

  /**
   * EndpointAccessEvent constructor.
   * 
   * @param \Drupal\rest_easy\Plugin\EndpointInterface $endpoint
   * @param \Drupal\Core\Access\AccessResultInterface $result
   */
  public function __construct(EndpointInterface $endpoint, AccessResultInterface $result) {
    $this->endpoint = $endpoint;
    $this->result = $result;
  }
}
