<?php

/**
 * @file
 * Define the endpoint call event.
 */

namespace Drupal\rest_easy\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\rest_easy\Plugin\EndpointInterface;
use Symfony\Component\HttpFoundation\Response;

/**
 * Class EndpointCallEvent
 *
 * @package Drupal\rest_easy\Event
 */
class EndpointCallEvent extends Event {
  public const EVENT_NAME = 'rest_easy_endpoint_call_event';

  /**
   * @var \Drupal\rest_easy\Plugin\EndpointInterface
   *   The endpoint plugin being called
   */
  public EndpointInterface $endpoint;

  /**
   * @var \Symfony\Component\HttpFoundation\Response
   *   The response object about to be returned
   */
  public Response $response;

  /**
   * EndpointCallEvent constructor.
   * 
   * @param \Drupal\rest_easy\Plugin\EndpointInterface $endpoint
   * @param \Symfony\Component\HttpFoundation\Response $response
   */
  public function __construct(EndpointInterface $endpoint, Response $response) {
    $this->endpoint = $endpoint;
    $this->response = $response;
  }
}
