<?php

/**
 * @file
 * Define the endpoint headers event.
 */

namespace Drupal\rest_easy\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\rest_easy\Plugin\EndpointInterface;

/**
 * Class EndpointHeadersEvent
 *
 * @package Drupal\rest_easy\Event
 */
class EndpointHeadersEvent extends Event {
  public const EVENT_NAME = 'rest_easy_endpoint_headers_event';

  /**
   * @var \Drupal\rest_easy\Plugin\EndpointInterface
   *   The endpoint plugin being called
   */
  public EndpointInterface $endpoint;

  /**
   * @var array
   *   The headers about to be sent with the response
   */
  public array $headers;

  /**
   * EndpointHeadersEvent constructor.
   * 
   * @param \Drupal\rest_easy\Plugin\EndpointInterface $endpoint
   * @param \Symfony\Component\HttpFoundation\Response $response
   */
  public function __construct(EndpointInterface $endpoint, array $headers) {
    $this->endpoint = $endpoint;
    $this->headers = $headers;
  }
}
