<?php

/**
 * @file
 * Define the endpoint route event.
 */

namespace Drupal\rest_easy\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\rest_easy\Plugin\EndpointInterface;
use Symfony\Component\Routing\Route;

/**
 * Class EndpointRouteEvent
 *
 * @package Drupal\rest_easy\Event
 */
class EndpointRouteEvent extends Event {
  public const EVENT_NAME = 'rest_easy_endpoint_route_event';

  /**
   * @var \Drupal\rest_easy\Plugin\EndpointInterface
   *   The endpoint plugin
   */
  public EndpointInterface $endpoint;

  /**
   * @var \Symfony\Component\Routing\Route
   *   The route for the endpoint
   */
  public Route $route;

  /**
   * EndpointRouteEvent constructor.
   * 
   * @param \Drupal\rest_easy\Plugin\EndpointInterface $endpoint
   * @param \Symfony\Component\Routing\Route $route
   */
  public function __construct(EndpointInterface $endpoint, Route $route) {
    $this->endpoint = $endpoint;
    $this->route = $route;
  }
}
