<?php

/**
 * @file
 * Define the parameter get event.
 */

namespace Drupal\rest_easy\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\rest_easy\Plugin\ParameterInterface;

/**
 * Class ParameterGetEvent
 *
 * @package Drupal\rest_easy\Event
 */
class ParameterGetEvent extends Event {
  public const EVENT_NAME = 'rest_easy_parameter_get_event';

  /**
   * @var \Drupal\rest_easy\Plugin\ParameterInterface
   *   The parameter plugin
   */
  public ParameterInterface $parameter;

  /**
   * @var mixed
   *   The value about to be passed
   */
  public mixed $value;

  /**
   * ParameterGetEvent constructor.
   * 
   * @param \Drupal\rest_easy\Plugin\ParameterInterface $parameter
   * @param mixed $value
   */
  public function __construct(ParameterInterface $parameter, mixed $value) {
    $this->parameter = $parameter;
    $this->value = $value;
  }
}
