<?php

/**
 * @file
 * Define the parameter validate event.
 */

namespace Drupal\rest_easy\Event;

use Drupal\Component\EventDispatcher\Event;
use Drupal\rest_easy\Plugin\ParameterInterface;

/**
 * Class ParameterValidateEvent
 *
 * @package Drupal\rest_easy\Event
 */
class ParameterValidateEvent extends Event {
  public const EVENT_NAME = 'rest_easy_parameter_validate_event';

  /**
   * @var \Drupal\rest_easy\Plugin\ParameterInterface
   *   The parameter plugin
   */
  public ParameterInterface $parameter;

  /**
   * @var array
   *   Validation errors that occurred
   */
  public array $errors;

  /**
   * ParameterValidateEvent constructor.
   * 
   * @param \Drupal\rest_easy\Plugin\ParameterInterface $parameter
   * @param mixed $value
   */
  public function __construct(ParameterInterface $parameter, array $errors) {
    $this->parameter = $parameter;
    $this->errors = $errors;
  }
}
