<?php

/**
 * @file
 * Define a expanded base class for endpoint plugins that access configuration entities.
 */

namespace Drupal\rest_easy\Plugin;

use Drupal\Core\Config\ConfigFactoryInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Class ConfigEndpointBase
 *
 * @package Drupal\rest_easy\Plugin
 */
abstract class ConfigEndpointBase extends EndpointBase {

  /**
   * @var \Drupal\Core\Config\ConfigFactoryInterface
   *   Config factory service
   */
  protected $config_factory;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    $instance = parent::create($container, $configuration, $plugin_id, $plugin_definition);
    $instance->setExtraProperties($container->get('config.factory'));
    return $instance;
  }

  /**
   * Add extra dependencies to the plugin.
   * 
   * @param \Drupal\Core\Config\ConfigFactoryInterface $config_factory
   * @return void
   */
  public function setExtraProperties(ConfigFactoryInterface $config_factory) {
    $this->config_factory = $config_factory;
  }
}
