<?php

/**
 * @file
 * Define a expanded base class for endpoint plugins that access content entities.
 */

namespace Drupal\rest_easy\Plugin;

use Drupal\Core\Entity\EntityTypeManagerInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;

/**
 * Class ContentEndpointBase
 *
 * @package Drupal\rest_easy\Plugin
 */
abstract class ContentEndpointBase extends EndpointBase {

  /**
   * @var \Drupal\Core\Entity\EntityTypeManagerInterface
   *   Entity type manager service
   */
  protected $entity_type_manager;

  /**
   * {@inheritdoc}
   */
  public static function create(ContainerInterface $container, array $configuration, $plugin_id, $plugin_definition) {
    $instance = parent::create($container, $configuration, $plugin_id, $plugin_definition);
    $instance->setExtraProperties($container->get('entity_type.manager'));
    return $instance;
  }

  /**
   * Add extra dependencies to the plugin.
   * 
   * @param \Drupal\Core\Entity\EntityTypeManagerInterface $entity_type_manager
   * @return void
   */
  public function setExtraProperties(EntityTypeManagerInterface $entity_type_manager) {
    $this->entity_type_manager = $entity_type_manager;
  }
}
