<?php

/**
 * @file
 * Define the methods every parameter plugin must implement.
 */

namespace Drupal\rest_easy\Plugin;

use Drupal\Component\Plugin\PluginInspectionInterface;

/**
 * Interface ParameterPluginInterface
 *
 * @package Drupal\rest_easy\Plugin
 */
interface ParameterInterface extends PluginInspectionInterface {

  /**
   * Retrieve the value of the parameter from the request.
   *
   * @return mixed
   */
  public function get(): mixed;

  /**
   * Validate the parameter value.
   *
   * @param $value
   *   The value of the parameter
   *
   * @return array
   *    An array of strings describing validation errors. If this is empty, validation was successful.
   */
  public function validate($value): array;
}
